package mak.mods.CobbleGenerator;

import ic2.api.Direction;
import ic2.api.EnergyNet;
import ic2.api.IEnergySink;
import ic2.api.IEnergyTile;
import ic2.api.INetworkClientTileEntityEventListener;
import ic2.api.INetworkDataProvider;
import ic2.api.INetworkUpdateListener;
import ic2.api.IWrenchable;

import java.util.List;

import net.minecraft.src.Block;
import net.minecraft.src.EntityItem;
import net.minecraft.src.EntityPlayer;
import net.minecraft.src.ItemStack;
import net.minecraft.src.TileEntity;

public class TileEntityCobbleGenerator extends TileEntity implements
		IWrenchable, IEnergyTile, IEnergySink, INetworkClientTileEntityEventListener,
		INetworkDataProvider, INetworkUpdateListener {

	private short facing;
	private boolean addedToEnergyNet;

	public TileEntityCobbleGenerator() {
		facing = 0;
		addedToEnergyNet = false;

	}
	
	public void invalidate() {
		if (addedToEnergyNet) {
			EnergyNet.getForWorld(worldObj).removeTileEntity(this);
			addedToEnergyNet = false;
		}

		super.invalidate();
	}

	public float getWrenchDropRate() {
		return 1.0F;
	}

	public boolean wrenchCanSetFacing(EntityPlayer entityplayer, int i) {
		return false;
	}

	public void setFacing(short facing) {
		this.facing = facing;
	}

	public boolean wrenchCanRemove(EntityPlayer entityplayer) {
		return true;
	}

	public short getFacing() {
		return this.facing;
	}

	public boolean isAddedToEnergyNet() {
		return this.addedToEnergyNet;
	}

	public boolean canUpdate() {
		return true;
	}

	public void updateEntity() {
		super.updateEntity();

		if (!this.addedToEnergyNet) {
			EnergyNet.getForWorld(this.worldObj).addTileEntity(this);
			this.addedToEnergyNet = true;
		}
	}

	@Override
	public void onNetworkEvent(EntityPlayer player, int event) {
		// TODO Auto-generated method stub
		System.out.println("Network data: " + event);
	}

	@Override
	public void onNetworkUpdate(String field) {
		// TODO Auto-generated method stub

	}

	@Override
	public List<String> getNetworkedFields() {
		// TODO Auto-generated method stub
		return null;
	}
	
	public boolean demandsEnergy() {
		return true;
	}
	
	public boolean acceptsEnergyFrom(TileEntity te, Direction direction) {
		return true;
	}
	
	public int injectEnergy(Direction direction, int injected) {
		if (injected > mod_CobbleGenerator.costOfABlock) {
			ItemStack stack = new ItemStack(Block.cobblestone);
			float f = worldObj.rand.nextFloat() * 0.8F + 0.1F;
			float f1 = worldObj.rand.nextFloat() * 0.8F + 0.1F;
			float f2 = worldObj.rand.nextFloat() * 0.8F + 0.1F;
			EntityItem entityitem = new EntityItem(worldObj, xCoord + f, yCoord + f1 + 0.5F, zCoord + f2, stack);
			float f3 = 0.05F;
			entityitem.motionX = (float) worldObj.rand.nextGaussian() * f3;
			entityitem.motionY = (float) worldObj.rand.nextGaussian() * f3 + 0.2F;
			entityitem.motionZ = (float) worldObj.rand.nextGaussian() * f3;
			worldObj.spawnEntityInWorld(entityitem);
			return injected - mod_CobbleGenerator.costOfABlock;
		}
		return 0;
	}

}
