package mak.mods.CobbleGenerator;

import ic2.api.Items;
import net.minecraft.src.Block;
import net.minecraft.src.CreativeTabs;
import net.minecraft.src.ItemStack;
import net.minecraftforge.common.Configuration;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.Mod.PreInit;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;

@Mod(modid = "cobbleGen", name = "Cobblestone generator", version = "0.1b")
public class mod_CobbleGenerator {

	public static Block cgeneratorBlock;
	public int cgeneratorId;
	public static int costOfABlock;
	public static CreativeTabs ic2tab;

	@Init
	public void load(FMLInitializationEvent event) {
		getIC2Tab();
		cgeneratorBlock = new BlockCobbleGenerator(cgeneratorId, 0);
		GameRegistry.registerTileEntity(TileEntityCobbleGenerator.class,
				"tileEntityCobbleGen");
		GameRegistry.registerBlock(cgeneratorBlock);
		LanguageRegistry.addName(cgeneratorBlock, "Cobblestone generator");
		this.addAllRecipes();

	}

	public static void getIC2Tab() {
		for (int i = 0; i < CreativeTabs.creativeTabArray.length; ++i) {
			if (CreativeTabs.creativeTabArray[i].getTabLabel() == "IC2") {
				ic2tab = CreativeTabs.creativeTabArray[i];
				return;
			}
		}
	}

	@PreInit
	public void init(FMLPreInitializationEvent event) {
		Configuration config = new Configuration(
				event.getSuggestedConfigurationFile());
		// loading the configuration from its file
		config.load();

		cgeneratorId = config.getBlock("blockCobbleStoneGenerator", 2987)
				.getInt();

		costOfABlock = config.get(Configuration.CATEGORY_GENERAL,
				"costOfACobble", 100).getInt();

		// saving the configuration to its file
		config.save();
	}

	private void addAllRecipes() {
		GameRegistry.addRecipe(new ItemStack(cgeneratorBlock), "ara", "lcw",
				"ara", 'a', Items.getItem("advancedAlloy"), 'r',
				Items.getItem("refinedIronIngot"), 'l',
				Items.getItem("lavaCell"), 'w', Items.getItem("waterCell"),
				'c', Items.getItem("electronicCircuit"));
	}
}
